<!DOCTYPE html>
<html>

<head>
  <meta charset='utf-8'>
  <title>Pizza 365 project</title>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload ="onPageLoading()">
  <div class="container">
    <p class="h3 text-center mt-5"> Chọn đồ uống </p>
    <div class="form-group col-12">
      <hr class="mt-5 mb-5" />
    </div>

    <div class="form-group">
      <label>Đồ uống:</label>
      <select id="drinking-select" class="form-control">
        <option>Chọn đồ uống</option>
      </select>
    </div>
    <button id="show-result" class="btn btn-primary w-25" onclick="onBtnDisplayClick()">Hiển thị</button>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
      "use strict"
      //đọc dữ liệu (bỏ qua)
      
      //bước 2:kiểm tra - bỏ qua 

      //bước 3: xử lý API
      var vXmlhttp = new XMLHttpRequest(); //tạo đối tượng request
      processAPI(vXmlhttp);
      //bước 4: hiển thị dữ liệu lên select 
      vXmlhttp.onreadystatechange =
        function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            fillDataToSelect(vXmlhttp.responseText);
          }
        };

    }

    //hàm xử lý khi ấn nút hiển thị
    function onBtnDisplayClick(){
      "use strict"
      //bước 0: tạo đối tượng thu thập 
        var vObjectData = {
          drinkValue: "",
          drinkText:""
        }
      //bước 1: thu thập dữ liệu từ select
        getDataFromSelect(vObjectData);
        console.log(vObjectData);
      //bước 2: kiểm tra dữ liệu (bỏ qua)

      //bước 3: hiển thị dữ liệu 
        displayData(vObjectData);

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //mã nguồn để load data về
    function sampleCodeLoadData() {
      var xhttp = new XMLHttpRequest();
      xhttp.onreadystatechange =
        function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            console.log(xhttp.responseText); //ghi response text ra console.log
          }
        };
      xhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      xhttp.send();
    }


    //hàm xử lý gửi yêu cầu đến sever thông qua API
    //input: là đối tượng Request 
    function processAPI(paramRequest){
      "use strict"
      paramRequest.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      paramRequest.send();
    }
    

    //hàm đổi dữ liệu vào select
    //input: là dữ liệu từ sever gửi về 
    function fillDataToSelect(paramData){
      "use strict"
     
      var vObjectData = JSON.parse(paramData); //convert từ json string sang object
      console.log(vObjectData); //ghi response text ra console.log

      var vSelect = document.getElementById("drinking-select");
      for(var bI = 0; bI < vObjectData.length ; bI++){
         var bOption  = document.createElement('option');
         bOption.value = vObjectData[bI].maNuocUong;
         bOption.innerHTML = vObjectData[bI].tenNuocUong;
         vSelect.appendChild(bOption);
      }

    }

    //hàm thu thập dữ liệu 
    //input: là đối tượng chứa đối tượng thu thập 
    function getDataFromSelect(paramObj){
      "use strict"
      var vSelect = document.getElementById("drinking-select");
      paramObj.drinkValue = vSelect.value;
      paramObj.drinkText = vSelect.options[vSelect.selectedIndex].text;
    }

    //hàm hiển thị dữ liệu 
    //input: là đối tượng dữ liệu được chọn 
    function displayData(paramObj){
      "use strict"
      console.log("Giá trị của select được chọn là: " + paramObj.drinkValue); 
      console.log("Nội dung của select được chọn là: " + paramObj.drinkText); 
    }
  </script>
</body>

</html>